// Classroommanagement MAus-Dienst
// programmiert von Martin Resch 2016
// für Windows, 32-Bit mit Verwendung von 32-Bit DLL
//
// 0.10 erste Version
//   + SSL verwenden
//   + Authentication mit md5
// 0.11
//   + winkeylock.dll integrieren (32 Bit)
//   + DisableTaskmgr
// 0.20
//   + AnalogWatch
//   + Nachricht on top
// 0.51
//   + disableBefehl, ShutdownIP
//   + vtr
// 0.52
//   + mit/ohne Uhr
// 0.53
//   + BUG: disableBefehl
// 0.54
//   + mit UDP
//   + mit LogMessage
// 0.60
//
//

unit mainunit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  lNetComponents, lNet, lNetSSL, lcommon,LCLType, windows,base,extctrls,
  BlockUnit, NachrichtUnit, IniFiles, md5, dynlibs;
Const
  Version = '0.60';
  Datum   = 'Dez 2016';
type
  THookDLLFunc = function():BOOL; cdecl;
  THookDLLSetNotifyFunc = function (HookNotifyWnd: HWND):BOOL; cdecl;
  THookDLLGetNotifyFunc = function ():HWND; cdecl;
  THookDLLSetPropertiesFunc = function(id:integer; value:longint):BOOL; cdecl;


type

  { TMausDienstForm }

  TMausDienstForm = class(TForm)
    LSSLSessionComponent1: TLSSLSessionComponent;
    LTCPComponent1: TLTCPComponent;
    LUDP: TLUDPComponent;
    DebugMemo: TMemo;
    TaskmgrTimer: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure LTCPComponent1Accept(aSocket: TLSocket);
    procedure LTCPComponent1Disconnect(aSocket: TLSocket);
    procedure LNET_Error(const msg: string; aSocket: TLSocket);  // TCP und UDP
    procedure LNET_Receive(aSocket: TLSocket);                   // TCP und UDP
    procedure TaskmgrTimerTimer(Sender: TObject);
    procedure LogMessage(msg : String);
  private
    MausDienst_MD5 : String;
    hLib : TLibHandle;
    { winkey DLL}
    SetShellHook   : THookDLLFunc;
    UnSetShellHook : THookDLLFunc;
    GetIsLocked    : THookDLLFunc;
    SetNotifyWnd   : THookDLLSetNotifyFunc;
    GetNotifyWnd   : THookDLLGetNotifyFunc;
    SetProperties  : THookDLLSetPropertiesFunc;
    DisableBefehl  : Boolean;
    ShutdownIP     : String;
    UDP_mode       : Boolean;
    { private declarations }
  public
    { public declarations }
  end;

Const
  DefMausDienstPort = 9731;

  ConfigFileName = 'mausdienst.cfg';
  MD5FileName    = 'md.md5';
  CertFileName   = 'md.cert';
  KeyFilename    = 'md.key';

  msg_Nachricht = 'NACHRICHT:';
  msg_Befehl    = 'BEFEHL:';
  msg_poweroff  = 'POWEROFF';
  msg_reboot    = 'REBOOT';
  msg_logout    = 'LOGOUT';
  msg_sperren   = 'SPERREN';
  msg_sperrenU  = 'SPERRENU';
  msg_freigeben = 'FREIGEBEN';

  msg_echo      = 'ECHO';

  // Shared WM_USER message constants for C and Pascal modules.

  sHookDll = 'winKeyLockHook.dll';

  WKL_CMD_INITIALIZED   = -1;
  WKL_CMD_VERSION       = 0;
  WKL_CMD_UPDATE_STATUS = 1;
  WKL_CMD_SHOW_LOCKED   = 2;
  WKL_CMD_LOCK          = 3;
  WKL_CMD_UNLOCK        = 4;
  WKL_CMD_HIDE_TASKMGR  = 5;

  // Interface for properties
  WKL_PROP_LOCKED           = 0;
  WKL_PROP_DO_BEEP          = 1;
  WKL_PROP_LOCK_KEYBOARD    = 2;
  WKL_PROP_LOCK_MOUSE_BTN   = 3;
  WKL_PROP_LOCK_MOUSE_MOVE  = 4;
  WKL_PROP_LOCK_MOUSE_WHEEL = 5;
  WKL_PROP_KEY_LOCK         = 6;
  WKL_PROP_KEY_UNLOCK       = 7;
  WKL_PROP_SCREEN_SAVER_OFF = 8;
  WKL_PROP_KEY_UNLOCK2      = 9;
  WKL_PROP_LOG              = 10;
  WKL_PROP_LOKED_IDX        = 11;
  WKL_PROP_UNLOKED_IDX      = 12;

  WKL_PROP_MAX              = 15;
var
  MausDienstForm: TMausDienstForm;

implementation

{$R *.lfm}

{ TMausDienstForm }

procedure TMausDienstForm.FormCreate(Sender: TObject);
var
  IniFile : TIniFile;
  ConfigFilePfad, MD5Pfad : String;
  DisableTaskmgr : Boolean;
  Datei, IPList    : TStringList;
  s,Pfad      : UniCodeString;
  ex          : Boolean;
  a1,a2,a3,a4 : integer;
  n           : integer;
  myIP,listIP : String;
begin
  //////////////////////////////
  //
  UDP_mode := false;
  /////////////////////////////
  DebugMemo.Clear;
  debug := True;
  TaskmgrTimer.enabled := false;
  Pfad := ExtractFilePath(Application.ExeName)+sHookDll;
  if fileexists(Pfad) then
    begin
      hLib:= SafeLoadLibrary(Pfad);
      if hLib <> 0 then
        begin
          pointer(SetShellHook)  := GetProcedureAddress(hLib,'SetShellHook');
          pointer(UnSetShellHook):= GetProcedureAddress(hLib,'UnSetShellHook');
          pointer(SetProperties) := GetProcedureAddress(hLib,'SetProperties');
          pointer(SetNotifyWnd)  := GetProcedureAddress(hLib,'SetNotifyWnd');
          pointer(GetNotifyWnd)  := GetProcedureAddress(hLib,'GetNotifyWnd');
          pointer(GetIsLocked)   := GetProcedureAddress(hLib,'GetIsLocked');
          if (SetShellHook=nil) or (UnSetShellHook=nil) or(SetProperties=nil) or (SetNotifyWnd=nil) or (GetNotifyWnd=nil) or (GetIsLocked=nil)
             then LogMessage('FEHLER: DLL-Funktionen unvollständig geladen')
             else LogMessage('DLL-Funktionen geladen.');;
          SetNotifyWnd(Handle);
        end
      else
        begin
          LogMessage('FEHLER: DLL konnte nicht geladen werden: '+ret+ret+Pfad);
        end;
    end
  else
    Begin
      LogMessage('FEHLER: DLL fehlt: '+ret+ret+Pfad);
    end;
  debug          := false;
  MausDienstPort := DefMausDienstPort;
  UseSSL         := false;
  DisableTaskmgr := false;
  DisableBefehl  := true;
  ShutdownIP     := '';
  ConfigFilePfad := ExtractFilePath(Application.ExeName) + ConfigFileName;
  if FileExists(ConfigFilePfad) then
    Begin
      IniFile := TIniFile.Create(ConfigFilePfad);
      Try with IniFile do
        Begin
          MausDienstPort := ReadInteger(MausDienst_sec,Port_entry,DefMausDienstPort);
          UseSSL         := Boolean(ReadInteger(MausDienst_sec,UseSSL_entry,0));
          debug          := Boolean(ReadInteger(MausDienst_sec,debug_entry,0));
          DisableTaskmgr := Boolean(ReadInteger(MausDienst_sec,Taskmgr_entry,0));
          UseAuth        := Boolean(ReadInteger(MausDienst_sec,UseAuth_entry,0));
          Sperrfarbe     := ReadString(MausDienst_sec,Farbe_entry,'$FFFFFF');
          Sperrtext      := ReadString(MausDienst_sec,Text_entry,'');
          MasterIP       := ReadString(MausDienst_sec,MasterIP_entry,'*');
          DisableBefehl  := Boolean(ReadInteger(MausDienst_sec,DisableBefehl_entry,1));
          ShutdownIP     := ReadString(MausDienst_sec,ShutdownIP_entry,'');
          LogMessage('Konfigurationsdatei geladen: '+ConfigFilePfad);
        end;
      finally
        IniFile.free;
      end;
    end;
  if UseAuth then
    Begin
      MD5Pfad := ExtractFilePath(Application.ExeName) + MD5FileName;
      if FileExists(MD5Pfad) then
        Begin
          Datei := TStringList.create;
          Datei.LoadFromFile(MD5Pfad);
          MausDienst_MD5 := Trim(Datei.text);
          Datei.free
        end;
    end;
  Caption := 'Maus Dienst '+Version+' ('+Datum+') ';
  if UDP_mode then
    Begin   ////////////////////////////////////// UDP /////////////////////
      LUDP.ReuseAddress:=True;
      If LUDP.Listen(MausDienstPort) then
        Begin
          if debug then
            Begin
              LogMessage('Eigene IP: '+IPauslesen);
              if UseSSL then s := ' + Use SSL' else s :='';
              If UseAuth then s := s + ' + Use Auth';
              LogMessage('Listen Port: '+IntToStr(MausDienstPort)+s);
              LogMessage('UDP-Server Listen ... ');
            end;
        end
      else
        Begin
          LogMessage('FEHLER: Server not Listen!');
        end;
    end    ////////////////////////////////////////////////////////////////
  else
    Begin  ////////////////////////////////////// TCP /////////////////////
      LTCPComponent1.ReuseAddress:=True;
      LSSLSessionComponent1.SSLActive := UseSSL;
      if UseSSL then
        Begin
          LSSLSessionComponent1.KeyFile := ExtractFilePath(Application.ExeName) + KeyFileName;
          LSSLSessionComponent1.CAFile  := ExtractFilePath(Application.ExeName) + CertFileName;
        end;
      LTCPComponent1.SocketNet := LAF_INET;  // IP V4
      If LTCPComponent1.Listen(MausDienstPort) then
        Begin
          if debug then
            Begin
              LogMessage('Eigene IP: '+IPauslesen);
              if UseSSL then s := ' + Use SSL' else s :='';
              If UseAuth then s := s + ' + Use Auth';
              LogMessage('Listen Port: '+IntToStr(MausDienstPort)+s);
              LogMessage('TCP-Server Connect ... ');
            end;
        end;
    end;  ////////////////////////////////////////////////////////////////
  if DisableTaskmgr then
    Begin
      TaskmgrTimer.Enabled:=True;
    end;
  if ShutdownIP<>'' then
    Begin
      ex := false;
      IPList := TStringList.create;
      IPList.commatext := ShutdownIP;
      for n := 0 to IPList.count-1 do
        Begin
          myIP := IPauslesen;
          listIP := Trim(IPList[n]);
          ZerlegeIP(myIP,a1,a2,a3,a4);
          if (listIP = myIP) then ex := True;
          if (listIP = IntToStr(a1)+'.'+IntToStr(a2)+'.'+IntToStr(a3)+'.*') then ex := True;
          if (listIP = IntToStr(a1)+'.'+IntToStr(a2)+'.*.*') then ex := True;
          if (listIP = IntToStr(a1)+'.'+IntToStr(a2)+'.*') then ex := True;
          if ex then break;
        end;
      IPList.free;
      if ex then
        Begin
          if debug then ShowMessage('Mausdienst wird beendet, da in ShutdownIP vorhanden:'+ret+ret+listIP);
          application.terminate;
        end;
    end;
end;


procedure TMausDienstForm.FormShow(Sender: TObject);
begin
  Top  := 10;
  Left := Screen.DesktopWidth-10-width;
 //ShowWindow(GetParent(Handle), SW_HIDE);
 //SetWindowLong(GetParent(Handle), GWL_EXSTYLE, getWindowLong(GetParent(Handle), GWL_EXSTYLE) or WS_EX_TOOLWINDOW);
 //ShowWindow(GetParent(Handle), SW_SHOW);
 //ShowInTaskBar := stnever;
  if not debug then MausDienstForm.Hide;
end;

procedure TMausDienstForm.LTCPComponent1Accept(aSocket: TLSocket);
begin
  if UDP_mode then exit;
  LogMessage('Client connected: '+aSocket.PeerAddress);
end;

procedure TMausDienstForm.LTCPComponent1Disconnect(aSocket: TLSocket);
begin
  if UDP_mode then exit;
  LogMessage('Disconnect ...');
end;

procedure TMausDienstForm.LNET_Error(const msg: string; aSocket: TLSocket);
begin
  LogMessage('FEHLER: '+msg);
end;

procedure TMausDienstForm.LNET_Receive(aSocket: TLSocket);
Var
   s,t,befehl    : String;
   a,b,i  : Integer;
   authOK : Boolean;
   pwd    : String;
begin
  LogMessage('Receive');
  if aSocket.GetMessage(s) > 0 then
    Begin
      if (MasterIP <>'*') and (Pos(aSocket.PeerAddress,MasterIP)=0) then
        Begin
          LogMessage('IP <'+aSocket.PeerAddress+'> ist nicht als Master-IP vorhanden:'+ret+'"'+MasterIP+'"');
          exit;
        end;
      s := Trim(s);
      LogMessage('Message: '+ s);
      authOK := false;
      if Useauth then
        Begin
          if s[1]='%' then
            Begin
              s := copy(s,2,length(s)-1);
              a := pos('%',s);
              if a>1 then
                Begin
                  pwd := vtr(Copy(s,1,a-1));
                  s   := Copy(s,a+1,length(s)-a);
                  if MD5print(MD5String(pwd))=MausDienst_md5 then authOK := True;
                end
            end;
        end;
      if authOK then LogMessage('Authentication erfolgreich ...');
      if Useauth and (not authOK) then
        Begin
          LogMessage('Authentication fehlgeschlagen!!!');
          exit;
        end;
      if s=msg_echo then
        Begin
          aSocket.SendMessage(msg_echo);
        end;
      if (s=msg_sperren) or (s=msg_sperrenU) then
        Begin
          for i := 1 to WKL_PROP_MAX-1 do SetProperties(i,0);
          SetShellHook;
          SetProperties(WKL_PROP_LOCK_KEYBOARD, 1);
          // Beispiele:
          // Keycode:    123 -> F11      16506 -> Strg + F11
          // Keycode:    124 -> F12      16507 -> Strg + F12
          // Keycode 22 ist nicht definiert!
          SetProperties(WKL_PROP_KEY_LOCK, 0);
          SetProperties(WKL_PROP_KEY_UNLOCK, 22);
          SetProperties(WKL_PROP_LOCK_MOUSE_BTN, 1);
          SetProperties(WKL_PROP_LOCK_MOUSE_Move, 1);
          SetProperties(WKL_PROP_LOCK_MOUSE_WHEEL, 1);
          if not SetProperties(WKL_PROP_LOCKED, 1)
             then
               Begin
                 LogMessage('FEHLER: Sperren ist fehlgeschlagen??'+IntToStr(Integer(GetIsLocked)))
               end
             else
               Begin
                 LogMessage('Sperren ausgefüht ...');
               end;
          BlockForm.Color:=StringToColor(Sperrfarbe);
          if Sperrtext <>'' then BlockForm.StaticText1.Caption:=Sperrtext;
          BlockForm.BorderStyle := bsNone;
          BlockForm.Left := 0;
          BlockForm.Top := 0;
          BlockForm.Width := Screen.Width;
          BlockForm.Height := Screen.Height;
          BlockForm.ShowInTaskBar:=stnever;
          ShowInTaskBar:=stnever;
          if s=msg_sperrenU then BlockForm.Analogwatch1.Visible:=true
                            else BlockForm.Analogwatch1.Visible:=false;
          BlockForm.show;
        end
      else if s=msg_freigeben then
        Begin
          SetProperties(WKL_PROP_LOCKED, 0);
          BlockForm.close;
          UnSetShellHook;
          LogMessage('Freigeben ausgefüht ...');
        end
      else if pos(msg_Nachricht,s)=1 then
        Begin
          t := Copy(s,length(msg_Nachricht)+1,length(s)-length(msg_Nachricht));
          NachrichtForm.Memo1.text :=t;
          NachrichtForm.Show;
        end
      else if (pos(msg_Befehl,s)=1) then
        Begin
          if DisableBefehl then
            Begin
              LogMessage('Befehlsausführung -> disabled !');
            end
          else
            Begin
              t := Copy(s,length(msg_Befehl)+1,length(s)-length(msg_Befehl));
              Befehl_exec(t);
              LogMessage(t);
              //aSocket.SendMessage('OK');
            end;
        end
      else if s=msg_logout then
        Begin
          Befehl_exec('shutdown.exe -l');
        end
      else if s=msg_poweroff then
        Begin
          Befehl_exec('shutdown.exe -s -f -t 00');
        end
      else if s=msg_reboot then
        Begin
          Befehl_exec('shutdown.exe -r -f -t 00');
        end
     end;
end;

procedure TMausDienstForm.TaskmgrTimerTimer(Sender: TObject);
Var
   Wnd : HWND;
begin
  Wnd := FindWindow(nil,'Task Manager');                           // ???
  if Wnd = 0 then Wnd := FindWindow(nil,'Windows Task-Manager');   // Windows 7
  if Wnd = 0 then Wnd := FindWindow(nil,'Task-Manager');           // Windows 10
  if Wnd <>0 then
    Begin
      LogMessage('Beende Taskmgr ...');
      PostMessage(Wnd, WM_CLOSE,0,0);
    end;
end;

procedure TMausDienstForm.LogMessage(msg:String);
begin
  if debug then DebugMemo.append(msg);
end;

end.

